﻿

;**************************************************************************
;*           VELLEMAN   High-Q KIT  K8048/VM111 SAMPLE SOFTWARE           *
;**************************************************************************
;*           DEMO1: Simple Running light for testing LD1...LD5            *
;*	     DEMO1: Program for testing K8048/VM111 with PIC16F627!       *
;**************************************************************************
;*          (C) VELLEMAN Components,2003  All rights reserved             *
;**************************************************************************
;*          Hardw. Rev: P8048'1          Softw. Rev:  1.20                *
;*          OSC.......: XT 4MHz Max.     POWER.....:  12V DC              *
;**************************************************************************

    processor 16F676
    #include "P16F676.INC"
    __config 0x3FE4



;==========================================================================
;
;       RAM Definition
;
;==========================================================================

;    __MAXRAM H'01FF'
;    __BADRAM H'07'-H'09', H'0D', H'13'-H'14', H'1B'-H'1E'
;    __BADRAM H'87'-H'89', H'8D', H'8F'-H'91', H'93'-H'97', H'9E'
;    __BADRAM H'105', H'107'-H'109', H'10C'-H'11F', H'150'-H'16F'
;    __BADRAM H'185', H'187'-H'189', H'18C'-H'1EF'


;==========================================================================
;       Variable Definition
;==========================================================================
W                            EQU     H'0000'
F                            EQU     H'0001'


;----- STATUS Bits --------------------------------------------------------
IRP                          EQU     H'0007'
RP1                          EQU     H'0006'
RP0                          EQU     H'0005'
NOT_TO                       EQU     H'0004'
NOT_PD                       EQU     H'0003'
Z                            EQU     H'0002'
DC                           EQU     H'0001'
C                            EQU     H'0000'
RAIE                         EQU     H'0003'
RAIF 	                     EQU     H'0000'


mrq			equ	H'0002'		;RC2
sda			equ H'0000'		;RC0
scl			equ H'0004'		;RC4
sda_in		equ	H'0002'		;RA2
mrq_in		equ H'0001'		;RC1
scl_in		equ H'0003'		;RC3
ir			equ	H'0005'		;RC5
dly_timer	equ 0x20
readed		equ	0x21		;sda_in bit ide van beolvasva
mrq_timer	equ	0x22
szamlalo	equ	0x23
odata		equ	0x24
eredmeny	equ 0x25
i2c_data	equ 0x26	
delay0_timer		equ 0x27
delay1_timer		equ	0x28
delay1_timer2		equ	0x29
ir_data				equ	0x2A
nyomott_gomb_kodja	equ 0x2B
kijelzes			equ	0x2C
first				equ 0x2D
second				equ 0x2E
init				equ 0x2F
gomb_holded			equ	0x30
ir_repeat			equ 0x31


		ORG	0		;Reset vector address
		GOTO	startcode		;goto RESET routine when boot.
		ORG 4
		GOTO	MEGSZAK
		
RESET	
		MOVLW	B'00000111'	;Disable Comparator module's
		MOVWF	CMCON
		;
		BSF	STATUS,RP0	;Switch to register bank 1
		MOVLW	B'01110100'
		MOVWF	OSCCAL
		CLRF	VRCON	;reference off
		MOVLW	B'00000000'	;Set PIC options (See datasheet).
		MOVWF	OPTION_REG	;Write the OPTION register.
		MOVLW	0xff
		MOVWF	WPUA
		CLRF	ANSEL		; Analóg bemenet digitálisra
		MOVLW	B'00000000'
		MOVWF	INTCON		;enable interrupts GIE, RAIE
		MOVLW	B'00110100'
		MOVWF	IOCA		;portváltozások 
		MOVLW	B'11111111'
		MOVWF	TRISA		;
		MOVLW	B'11000000'	;
		MOVWF	TRISC
		BCF	STATUS,RP0	;Switch Back to reg. Bank 0
		CLRF	PORTA
		CLRF	PORTC
		CLRWDT

		BCF		gomb_holded,0
		RETURN
startcode
	CALL	RESET
	CALL	impulzusok
	BCF		INTCON,RAIF
	BSF		INTCON,7
	BSF		INTCON,RAIE
	CLRWDT
	
nahonnan
	CLRF	PORTC
	MOVLW	0x20
	MOVWF	dly_timer
nainnen
	CLRF	PORTC
	CLRF	nyomott_gomb_kodja
	CALL	impulzusok
	CALL	impulzusok
	SLEEP
	nop
	GOTO	nainnen

;----------------------billentyűlekérdezés--------------------------
MEGSZAK

		btfsc INTCON,RAIF ;change on rb int?
		goto keyread ;yes then service
		CALL	lines_on
		retfie
keyread
	BCF 	INTCON,RAIE
	BCF 	INTCON,RAIF

	
keymatrix			
	BCF 	INTCON,RAIE
	BCF 	INTCON,RAIF
;	BSF		PORTC,4
	CALL	delay
	CLRF	PORTC
	; line1
	CALL	line1_on	;BCF		PORTC,0
	CALL	negyed_clock
	BTFSS	PORTA,5
	goto	tunedwn
	BTFSS	PORTA,4
	goto	pwr
	BTFSS	PORTA,2
	goto	volup

	; line2
	CALL	line2_on	;BCF		PORTC,1
	CALL	negyed_clock
	BTFSS	PORTA,5
	goto	chup
	BTFSS	PORTA,4
	goto	nokey
	BTFSS	PORTA,2
	goto	tuneup

	; line3
	CALL	line3_on	;BCF		PORTC,2
	CALL	negyed_clock
	BTFSS	PORTA,5
	goto	chdwn
	BTFSS	PORTA,4
	goto	nokey
	BTFSS	PORTA,2
	goto	nokey

	;line4
	CALL	line4_on	;BCF		PORTC,3
	CALL	negyed_clock
	BTFSS	PORTA,5
	goto	voldown
	BTFSS	PORTA,4
	goto	store
	BTFSS	PORTA,2
	goto	amfm

;	CALL	RESET
nokey
	CLRF	PORTC
	CALL	lines_on
	BCF		INTCON,RAIF
	BSF		INTCON,RAIE
	RETFIE	

pwr
	MOVLW	0x70
	goto	dataout	
chup
	MOVLW	0x22
	goto	dataout
chdwn
	MOVLW	0xb8 
	goto	dataout
store
	MOVLW	0xa8
	goto	dataout
voldown
	MOVLW	0x68
	goto	dataout
volup
	MOVLW	0x2a
	goto	dataout
tuneup
	MOVLW	0x12
	goto	dataout
tunedwn	
	MOVLW	0x38
	goto	dataout	
amfm	
	MOVLW	0x32
	goto	dataout	

dataout		
	MOVWF	eredmeny
	CALL	line_off
	BCF		STATUS,Z
	SUBWF	nyomott_gomb_kodja,1	;nyomott_gomb_kodja-ból kivonjuk W-t
	BTFSC	STATUS,Z 				;ha Zero, akkor ugyanazagom, 
	GOTO	repeat_code				;akkor ugrás ismétlésre
								;ha nemzéró, akkor kiküldjük.
	
	BCF		gomb_holded,0			;változott a gomb	
	MOVWF	nyomott_gomb_kodja
	CALL	remote_out

	goto	keymatrix
		


;-------------------------------IR kimenet írása--------------------

remote_out
	CLRWDT

remote_out_full	
    CALL start_impuls	 		; start impulzus
	CALL	remote_data			;ir out
	MOVLW d'33'           		;   b'00001001'  d'009' 8ms
   CALL delay1

	RETURN
	
remote_data	
    MOVLW b'00000000'           ;   JVC device code
    MOVWF ir_data	
    CALL irbyte_out	 			; bájt kiadás
    MOVLW b'11111111'           ;   JVC device code
    MOVWF ir_data	
    CALL irbyte_out	 			; bájt kiadás
    MOVF eredmeny,W				; nyomógomb kód beolvasás
    MOVWF ir_data
    CALL irbyte_out				; bájt kiadás
    COMF eredmeny,W	; nyomógomb kód beolvasás
    MOVWF ir_data
    CALL irbyte_out				; bájt kiadás
    CALL zero_bit				; Záró nulla bit?
    RETURN
	;----------ha nyomott a gomb, akkor 3x küldjük ki az üzenetet, de csak az elsőnél van header
repeat_code

	MOVWF	nyomott_gomb_kodja
megmindigazagomb
	MOVLW d'55'          ;   b'00000100'  d'004' 42ms első késleltetés 42ms
    CALL delay1


repeat_cont
	MOVLW d'16'          ;   9ms on
    CALL delay1on
	MOVLW d'5'          ;   2ms off
    CALL delay1
	CALL	one_bit
	MOVLW	d'155'
	CALL	delay1
	goto 	keyread
	
;send_hold_key
;
;	BCF	nyomott_gomb_kodja,1	;kinullázzuk
;	MOVLW	0x30			;0x20
;	MOVWF	ir_repeat
;send_repeat	
;	CALL	remote_data		;ir out
;	MOVLW d'33'           ;   b'00001001'  d'020' 10ms
;   CALL delay1
;	DECFSZ	ir_repeat,F
;	GOTO	send_repeat
;	RETURN
;--------------remote subrutinok------------	
start_impuls			; START_impulzus 9ms-ig alacsony, aztán 4ms szünet
    BSF PORTC,ir        ; !!Bank!! PORTA - TRISA
    MOVLW d'16'         ;   b'00001001'  d'009' 8ms
    CALL delay1on
    BCF PORTC,ir        ; !!Bank!! PORTA - TRISA
    MOVLW d'9'          ;   b'00000100'  d'004' 4ms
    CALL delay1
    RETURN
one_bit		 ; EGYES bit
    BSF PORTC,ir          ; !!Bank!! PORTA - TRISA
    CALL delayon
    BCF PORTC,ir          ; !!Bank!! PORTA - TRISA
    CALL delay
    CALL delay
    CALL delay
    RETURN
zero_bit		 ;  NULLA bit
    BSF PORTC,ir          ;  KIMENET be
    CALL delayon
    BCF PORTC,ir          ;  KIMENET ki
    CALL delay
    RETURN
;---------------------------------------------------------

irbyte_out		; adat kiírás 1 bájt
    BTFSS ir_data,7
    CALL zero_bit
    BTFSC ir_data,7
    CALL one_bit
    BTFSS ir_data,6
    CALL zero_bit
    BTFSC ir_data,6
    CALL one_bit
    BTFSS ir_data,5
    CALL zero_bit
    BTFSC ir_data,5
    CALL one_bit
    BTFSS ir_data,4
    CALL zero_bit
    BTFSC ir_data,4
    CALL one_bit
    BTFSS ir_data,3
    CALL zero_bit
    BTFSC ir_data,3
    CALL one_bit
    BTFSS ir_data,2
    CALL zero_bit
    BTFSC ir_data,2
    CALL one_bit
    BTFSS ir_data,1
    CALL zero_bit
    BTFSC ir_data,1
    CALL one_bit
    BTFSS ir_data,0
    CALL zero_bit
    BTFSC ir_data,0
    CALL one_bit
    RETURN
	
delay		 ; időzítés 0,5ms
    MOVLW 	d'195'		;0xb3           ;   b'10111001'  d'185'
    MOVWF delay0_timer
delay0
    DECFSZ delay0_timer,F
    GOTO delay0
    RETURN
	
delayon		 ; időzítés 0,5ms
    MOVLW 	d'21'		;0xb3           ;   b'10111001'  d'185'
    MOVWF delay0_timer
delay0on
	BSF		PORTC,ir
	nop
	nop
	nop
	nop
	nop
	BCF		PORTC,ir
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop


    DECFSZ delay0_timer,F
    GOTO delay0on
    RETURN	
;---------------------------------------------------------
delay1on		; időzítés/ késleltetés 0,5ms X delay1_timer
    MOVWF delay1_timer
delay1on_loop1
	call	delayon
    DECFSZ delay1_timer,F
    GOTO delay1on_loop1
    RETURN

delay1		; időzítés/ késleltetés 0,5ms X delay1_timer
    MOVWF delay1_timer
delay1_loop1
    NOP
    MOVLW 0xb3           ;   0,5ms= ab
    MOVWF delay1_timer2
delay1_loop2
    DECFSZ delay1_timer2,F
    GOTO delay1_loop2
    DECFSZ delay1_timer,F
    GOTO delay1_loop1
    RETURN
;----------------------------IR_remote block vége----------------------------
line1_on
	BSF		STATUS,RP0
	MOVLW	B'11001110
	MOVWF	TRISC
	BCF		STATUS,RP0
	RETURN
line2_on
	BSF		STATUS,RP0
	MOVLW	B'11001101
	MOVWF	TRISC
	BCF		STATUS,RP0
	RETURN
line3_on
	BSF		STATUS,RP0
	MOVLW	B'11001011
	MOVWF	TRISC
	BCF		STATUS,RP0
	RETURN
line4_on
	BSF		STATUS,RP0
	MOVLW	B'11000111
	MOVWF	TRISC
	BCF		STATUS,RP0
	RETURN
line_off
	BSF		STATUS,RP0
	MOVLW	B'11001111
	MOVWF	TRISC
	BCF		STATUS,RP0
	RETURN
lines_on
	CLRF	PORTC
	BSF		STATUS,RP0
	MOVLW	B'11000000
	MOVWF	TRISC
	BCF		STATUS,RP0
	RETURN
;------------------------------időzítés_negyed--------------------------
negyed_clock					 ; időzítés
    MOVLW 0x0B           ;  
    MOVWF dly_timer
negyed_clock_loop
    DECFSZ dly_timer,F
    GOTO negyed_clock_loop
    RETURN
;------------------------------időzítés_fél----------------------------------------------------
half_clock					 ; időzítés
    MOVLW 0x16           ; 
    MOVWF dly_timer
half_clock_loop
    DECFSZ dly_timer,F
    GOTO half_clock_loop
    RETURN	

;------------------------------időzítés_mrq----------------------------------------------------
mrq_delay					 ; időzítés
    MOVLW 0xA0           ; 
    MOVWF mrq_timer
mrq_delay_loop
    DECFSZ mrq_timer,F
    GOTO mrq_delay_loop
    RETURN	

;--------------------------mrq várása-------------------
varunk		

	BTFSC	PORTC,mrq_in
	GOTO	varunk
	RETURN
impulzusok
	BSF		PORTC,4
	call	mrq_delay
	BCF		PORTC,4
	call	mrq_delay
	BSF		PORTC,4
	call	mrq_delay
	call	mrq_delay
	BCF		PORTC,4
	call	mrq_delay
	BSF		PORTC,4
	call	mrq_delay
	call	mrq_delay
	call	mrq_delay
	BCF		PORTC,4	
	RETURN

	END
